<template>
	<view class="content">
		<scroll-view scroll-x="true" class="class-box flex" :scroll-left="scrollLeft" :scroll-with-animation="true">
			<view @click="tabClick(idx)" class="item"  v-for="(item, idx) in navList" :key="idx" >
				<view class="time" :class="{ action: idx == tabCurrentIndex }">{{ item.text }}</view>
			</view>
		</scroll-view>
<!-- 		<view class="navbar">
			<view v-for="(item, index) in navList" :key="index" class="nav-item" :class="{ current: tabCurrentIndex === index }" @click="tabClick(index)">{{ item.text }}</view>
		</view> -->

		<swiper :current="tabCurrentIndex" class="swiper-box" duration="300" @change="changeTab">
			<swiper-item class="tab-content" v-for="(tabItem, tabIndex) in navList" :key="tabIndex">
				<scroll-view class="list-scroll-content" scroll-y @scrolltolower="loadData">
					<!-- 空白页 -->
					<empty v-if="tabItem.loaded === true && tabItem.orderList.length === 0"></empty>

					<!-- 订单列表 -->
					<view  v-for="(item, index) in tabItem.orderList" :key="index" class="order-item" @click="tz(item)">
						<view class="item-top flex">
							<view class="item-number">
								项目编号：{{item.order_sn}}
							</view>
							<!-- <view class="item-status" v-if="item.status === 0" style="color: #FA7E67;">审核中</view>
							<view class="item-status" v-if="item.status === 2" style="color: #FA7E67;">进行中</view>
							<view class="item-status" v-if="item.status === 3" style="color: #FA7E67;">已完成</view> -->
							<view class="item-status" v-if="item.order_status === -1" style="color: #999999">{{item.status_txt}}</view>
							<view class="item-status" v-else style="color: #FA7E67;">{{item.status_txt === '受捐者反馈'? '已完成':item.status_txt}}</view>
						</view>
						<view class="item-main flex">
							<image :src="item.img" mode="" v-if="item.img"></image>
							<image src="../../static/img/moren.png" mode="" v-else></image>
							<view class="item-info">
								<view class="info-title">
									{{item.title}}
								</view>
								<view class="info-content">
									项目进度: 您的捐赠{{item.order_status === 0 ? '正在审核中,请耐心等待':item.order_status === -1 ? ' 审核未通过,感谢您的爱心!' : '审核已通过' }}
								</view>
								<view class="info-time">
									申请时间 {{item.add_time | time}}
								</view>
							</view>
						</view>
						<view class="item-bottom flex" v-if="item.order_status >= 1">
							<!-- <view class="yxs" @click="navTo('/pages/user/intent')">
								捐献意向书
							</view> -->
							<view class="zs"  @click.stop="navTo('/pages/user/thank?project_id='+item.project_id + '&name=' + item.name + '&time=' + item.add_time+'&title=' + item.title ||'')"  v-if="item.order_status == 6">
								捐赠证书
							</view>
						</view>
					</view>

					<uni-load-more :status="tabItem.loadingType"></uni-load-more>
				</scroll-view>
			</swiper-item>
		</swiper>
	</view>
</template>

<script>
import uniLoadMore from '@/components/uni-load-more/uni-load-more.vue';
import empty from '@/components/empty';
import { mapState } from 'vuex';
import { saveUrl } from '@/utils/loginUtils.js';
import { orderList, orderCancel, orderDel, orderTake } from '@/api/order.js';
import { getProjectInfo, createProject, getDonationInfo, getMyorder} from '../../api/money.js';
export default {
	filters: {
		time(val) {
			let str =''
			if(val){
				let date = new Date(val * 1000);
				let Y = date.getFullYear();
				let M = (date.getMonth()+1) > 9 ? (date.getMonth()+1) : '0' + (date.getMonth()+1);
				let D = date.getDate() > 9 ? date.getDate() : '0' + date.getDate();
				str =  Y + '-' + M + '-' + D ;
			}
			return str
		},
	},
	components: {
		uniLoadMore,
		empty
	},
	data() {
		return {
			tabCurrentIndex: 0,
			state: '',
			showModal: false,
			itemWidht: '60',
			navList: [
				{
					state: -2,
					text: '全部',
					loadingType: 'more',
					orderList: [
					],
					page: 1, //当前页数
					limit: 10 //每次信息条数
				},
					
				{
					state: -1,
					text: '未通过',
					loadingType: 'more',
					orderList: [
					],
					page: 1, //当前页数
					limit: 10 //每次信息条数
				},
				{
					state: 0,
					text: '审核中',
					loadingType: 'more',
					orderList: [],
					page: 1, //当前页数
					limit: 10 //每次信息条数
				},
				{
					state: 1,
					text: '审核通过',
					loadingType: 'more',
					orderList: [],
					page: 1, //当前页数
					limit: 10 //每次信息条数
				},
				{
					state: 2,
					text: '已发货',
					loadingType: 'more',
					orderList: [],
					page: 1, //当前页数
					limit: 10 //每次信息条数
				},
				{
					state: 3,
					text: '已入库',
					loadingType: 'more',
					orderList: [],
					page: 1, //当前页数
					limit: 10 //每次信息条数
				},
				{
					state: 4,
					text: '已出库',
					loadingType: 'more',
					orderList: [],
					page: 1, //当前页数
					limit: 10 //每次信息条数
				},
				// {
				// 	state: 5,
				// 	text: '发受捐者',
				// 	loadingType: 'more',
				// 	orderList: [],
				// 	page: 1, //当前页数
				// 	limit: 10 //每次信息条数
				// },
				{
					state: 6,
					text: '已完成',
					loadingType: 'more',
					orderList: [],
					page: 1, //当前页数
					limit: 10 //每次信息条数
				}
			]
		}
	},
	onLoad(options) {
		this.state = options.state*1;
		console.log(this.state)
		saveUrl();
		/**
		 * 修复app端点击除全部订单外的按钮进入时不加载数据的问题
		 * 替换onLoad下代码即可
		 */
		// this.tabCurrentIndex = options.state;
		// #ifndef MP
		this.loadData();
		// #endif
		// #ifdef MP
		if (options.state == -2) {
			this.loadData();
		}
		// #endif
		// this.getMyorder()
	},
	computed: {
		...mapState(['userInfo']),
		scrollLeft() {
			if (this.tabCurrentIndex > 1) {
				console.log(this.itemWidht * (this.tabCurrentIndex - 1.5))
				return this.itemWidht * (this.tabCurrentIndex - 1.5);
				// return this.itemWidht * this.tabCurrentIndex
			} else {
				return 0;
			}
		}
	},
	methods: {
		// 确认收货
		orderTake(item, index) {
			let obj = this;
			uni.showModal({
				title: '是否确认收货？',
				success: function(res) {
					if (res.confirm) {
						orderTake({
							uni: item.order_id
						})
							.then(e => {
								obj.navList[obj.tabCurrentIndex].orderList.splice(index, 1);
								uni.showToast({
									title: '收货成功',
									icon: 'none'
								});
							})
							.catch(e => {
								console.log(e);
							});
					} else if (res.cancel) {
						console.log('用户点击取消');
					}
				}
			});
		},
		// 跳转到查询快递页面
		expressCheck(item) {
			uni.navigateTo({
				url: '/pages/order/expressInfo?id=' + item.id
			});
		},

		//跳转到订单详情
		goToOrderDetail(e) {
			uni.navigateTo({
				url: '/pages/order/orderDetail?id=' + e.order_id
			});
		},

		//分享
		share(e) {
			console.log(e);
			uni.navigateTo({
				url: '/pages/product/details?pink_id=' + e.pink_id
			});
		},
		// 申请退款
		orderRefund(e) {
			uni.navigateTo({
				url: '/pages/order/orderRefund?id=' + e.order_id
			});
		},
		// 订单支付
		orderPay(e) {
			if (e.combination_id > 0) {
				uni.navigateTo({
					url: '/pages/money/pay?type=1&ordid=' + e.order_id + '&money=' + e.pay_price + '&goodsType=2'
				});
			} else {
				uni.navigateTo({
					url: '/pages/money/pay?type=1&ordid=' + e.order_id + '&money=' + e.pay_price
				});
			}
			
		},
		//获取订单列表
		loadData(source) {
			//这里是将订单挂载到tab列表下
			let index = this.tabCurrentIndex;
			let navItem = this.navList[index];
			let state = navItem.state;
			if (source === 'tabChange' && navItem.loaded === true) {
				//tab切换只有第一次需要加载数据
				return;
			}
			if (navItem.loadingType === 'loading') {
				//防止重复加载
				return;
			}
			if (navItem.loadingType === 'noMore') {
				//防止重复加载
				return;
			}
			// 修改当前对象状态为加载中
			navItem.loadingType = 'loading';
			
				getMyorder({
					page: navItem.page,
					limit: navItem.limit,
					status: state
				}).then( ({data}) => {
					console.log( data,'888888888888888888888888')
					// let arr = data.list.map( item => {
					// 	return e
					// })
					if(data.list) {
						data.list = data.list.map(item => {
							if(item.project_id !== 0){
								getProjectInfo({
									id: item.project_id
								}).then( res => {
									
									let data = res.data
									console.log(data,'project_id+++++++++++++++++++')
									// item.img = data.img
									this.$set(item,'img',data.img)
									this.$set(item,'title',data.title)
									console.log(item)
								})
							}else {
								this.$set(item,'img','')
								this.$set(item,'title',item.name+'的爱心捐赠')
							}
							
							return item
						})
					}
					// console.log(arr,'99999999999999999999999999')
					navItem.orderList = navItem.orderList.concat(data.list)
					console.log(navItem.orderList,'++++++++++++++++++++++')
					navItem.page++;
					if(navItem.limit == data.list.length) {
						navItem.loadingType = 'more';
						return 
					}else {
						navItem.loadingType = 'noMore';
					}
					this.$set(navItem, 'loaded', true);
				}).catch( err => {
					console.log(err)
				})
			
			
			// orderList({
			// 	type: state,
			// 	page: navItem.page,
			// 	limit: navItem.limit
			// })
			// 	.then(({ data }) => {
			// 		let arr = data.map(e => {
			// 			let b = this.orderStateExp(e.status);
			// 			e.stateTip = b.stateTip;
			// 			e.stateTipColor = b.stateTipColor;
			// 			return e;
			// 		});
			// 		navItem.orderList = navItem.orderList.concat(arr);
			// 		// console.log(navItem.orderList);
			// 		navItem.page++;
			// 		if (navItem.limit == data.length) {
			// 			//判断是否还有数据， 有改为 more， 没有改为noMore
			// 			navItem.loadingType = 'more';
			// 			return;
			// 		} else {
			// 			//判断是否还有数据， 有改为 more， 没有改为noMore
			// 			navItem.loadingType = 'noMore';
			// 		}
			// 		this.$set(navItem, 'loaded', true);
			// 	})
			// 	.catch(e => {
			// 		console.log(e);
			// 	});
			
		},

		//swiper 切换
		changeTab(e) {
			this.tabCurrentIndex = e.target.current;
			this.loadData('tabChange');
		},
		//顶部tab点击
		tabClick(index) {
			this.tabCurrentIndex = index;
			this.loadData('tabChange');
		},
		//删除订单
		deleteOrder(item, index) {
			uni.showModal({
				content: '是否确认删除订单？',
				success: res => {
					uni.showLoading({
						title: '请稍后'
					});
					setTimeout((e) => {
						orderDel({
							uni: item.order_id
						})
							.then(e => {
								this.navList[this.tabCurrentIndex].orderList.splice(index, 1);
								uni.hideLoading();
							})
							.catch(e => {
								console.log(e);
								uni.hideLoading();
							});
					},1000)
				},
				fail: e => {
					console.log(e);
				}
			});
		},
		

		//订单状态文字和颜色
		orderStateExp(state) {
			let stateTip = '',
				stateTipColor = '#EF041F';
			switch (+state) {
				case 0:
					stateTip = '全部';
					break;
				case 1:
					stateTip = '待付款';
					break;
				case 2:
					stateTip = '待发货';
					break;
				case 3:
					stateTip = '待收货';
					break;
				case 4:
					stateTip = '已完成';
					stateTipColor = '#5dbc7c';
					break;
				case 9:
					stateTip = '订单已关闭';
					stateTipColor = '#909399';
					break;

				//更多自定义
			}
			return { stateTip, stateTipColor };
		},
		navTo(url) {
			uni.navigateTo({
				url: url
			})
		},
		getMyorder() {
			getMyorder({
				status: 6
			}).then(res => {
				console.log(res,'66666666666666')
			})
		},
		tz(item) {
			console.log(item)
			if(item.project_id !== 0){
				uni.navigateTo({
					url: '/pages/donate/donateDetail?id=' + item.project_id
				})
			}
			
		}
		
	}
};
</script>

<style lang="scss">
page,
.content {
	background: $page-color-base;
	height: 100%;
}

.swiper-box {
	height: calc(100% - 40px);
	// padding: 0 20rpx;
}
.list-scroll-content {
	height: 100%;
}

.navbar {
	display: flex;
	height: 40px;
	padding: 0 5px;
	background: #fff;
	box-shadow: 0 1px 5px rgba(0, 0, 0, 0.06);
	position: relative;
	z-index: 10;
	.nav-item {
		width: 250rpx;
		flex: 1;
		display: flex;
		justify-content: center;
		align-items: center;
		height: 100%;
		font-size: 15px;
		color: $font-color-dark;
		position: relative;
		&.current {
			color: #FF0000;
			&:after {
				content: '';
				position: absolute;
				left: 50%;
				bottom: 0;
				transform: translateX(-50%);
				width: 44px;
				height: 0;
				border-bottom: 2px solid #FF0000;
			}
		}
	}
}

.uni-swiper-item {
	height: auto;
}
.order-item {
	background-color: #fff;
	padding: 0 20rpx;
	margin-bottom: 15rpx;
	margin-top: 15rpx;
	.item-top {
		justify-content: space-between;
		height: 79rpx;
		border-bottom: 1px solid  #E1E1E5;
		line-height: 79rpx;
		font-size: 26rpx;
		font-family: PingFang SC;
		font-weight: bold;
		color: #333333;
	}
	.item-main {
		height: 210rpx;
		align-items: center;
		image {
			width: 220rpx;
			height: 170rpx;
			background: #FFFFFF;
			border: 1px solid #DDDDDD;
			border-radius: 10rpx;
			margin: 18rpx;
		}
		.item-info {
			width: 471rpx;
			height: 170rpx;
			position: relative;
			.info-title {
				font-size: 32rpx;
				// font-size: 24rpx;
				font-family: PingFang SC;
				font-weight: bold;
				color: #323232;
				line-height: 1;
				// position: absolute;
				// top: 0;
			}
			.info-content {
				padding-top: 14rpx;
				font-size: 22rpx;
				font-family: PingFang SC;
				font-weight: 500;
				color: #666666;
				line-height: 1.5;
			}
			.info-time {
				font-size: 22rpx;
				font-family: PingFang SC;
				font-weight: 500;
				color: #999999;
				position: absolute;
				right: 0;
				bottom: 0;
			}
		}
		
	}
	.item-bottom {
		height: 96rpx;
		border-top: 1px solid  #E1E1E5;
		justify-content: flex-end;
		align-items: center;
		view {
			width: 144rpx;
			height: 55rpx;
			line-height: 55rpx;
			text-align: center;
			border-radius: 28rpx;
			font-size: 24rpx;
			font-family: PingFang SC;
			font-weight: 500;
		}
		.yxs {		
			border: 2px solid #FA7E67;
			color: #FA7E67;
			line-height: 50rpx;
		}
		.zs {
			background: #FA7E67;
			color: #fff;
			margin-left: 15rpx;
		}
	}
}

// 积分投注弹窗
.mask {
	z-index: 10;
	position: fixed;
	top: 0;
	right: 0;
	bottom: 0;
	left: 0;
	background-color: rgba(0, 0, 0, 0.5);
	width: 100%;
	height: 100%;
	display: flex;
	justify-content: center;
	align-items: center;
	flex-direction: column;
	.pop {
		z-index: 12;
		width: 560rpx;
		height: 379rpx;
		background: rgba(255, 255, 255, 1);
		border-radius: 30px;
		.pop-box {
			width: 100%;
			height: 100%;
			display: flex;
			flex-direction: column;
			text-align: center;
			align-items: center;
			margin-top: -72rpx !important;
			.pop-img {
				width: 177rpx;
				height: 186rpx;
				margin-bottom: 34rpx;
			}
			.pop-title {
				height: 34rpx;
				font-size: 36rpx;
				font-weight: 500;
				color: rgba(51, 51, 51, 1);
				margin-bottom: 32rpx;
			}
			.number {
				width: 454rpx;
				height: 78rpx;
				background: rgba(234, 234, 234, 1);
				background: #eaeaea;
			}
		}
		//关闭按钮
		.close-box {
			margin-top: 130rpx;
			text-align: center;
			.close {
				width: 83rpx;
				height: 83rpx;
			}
		}
	}
}

/* load-more */
.uni-load-more {
	display: flex;
	flex-direction: row;
	height: 80rpx;
	align-items: center;
	justify-content: center;
}

.uni-load-more__text {
	font-size: 28rpx;
	color: #999;
}

.uni-load-more__img {
	height: 24px;
	width: 24px;
	margin-right: 10px;
}

.uni-load-more__img > view {
	position: absolute;
}

.uni-load-more__img > view view {
	width: 6px;
	height: 2px;
	border-top-left-radius: 1px;
	border-bottom-left-radius: 1px;
	background: #999;
	position: absolute;
	opacity: 0.2;
	transform-origin: 50%;
	animation: load 1.56s ease infinite;
}

.uni-load-more__img > view view:nth-child(1) {
	transform: rotate(90deg);
	top: 2px;
	left: 9px;
}

.uni-load-more__img > view view:nth-child(2) {
	transform: rotate(180deg);
	top: 11px;
	right: 0;
}

.uni-load-more__img > view view:nth-child(3) {
	transform: rotate(270deg);
	bottom: 2px;
	left: 9px;
}

.uni-load-more__img > view view:nth-child(4) {
	top: 11px;
	left: 0;
}

.load1,
.load2,
.load3 {
	height: 24px;
	width: 24px;
}

.load2 {
	transform: rotate(30deg);
}

.load3 {
	transform: rotate(60deg);
}

.load1 view:nth-child(1) {
	animation-delay: 0s;
}

.load2 view:nth-child(1) {
	animation-delay: 0.13s;
}

.load3 view:nth-child(1) {
	animation-delay: 0.26s;
}

.load1 view:nth-child(2) {
	animation-delay: 0.39s;
}

.load2 view:nth-child(2) {
	animation-delay: 0.52s;
}

.load3 view:nth-child(2) {
	animation-delay: 0.65s;
}

.load1 view:nth-child(3) {
	animation-delay: 0.78s;
}

.load2 view:nth-child(3) {
	animation-delay: 0.91s;
}

.load3 view:nth-child(3) {
	animation-delay: 1.04s;
}

.load1 view:nth-child(4) {
	animation-delay: 1.17s;
}

.load2 view:nth-child(4) {
	animation-delay: 1.3s;
}

.load3 view:nth-child(4) {
	animation-delay: 1.43s;
}

@-webkit-keyframes load {
	0% {
		opacity: 1;
	}

	100% {
		opacity: 0.2;
	}
}
.class-box {
	background: #FFFFFF;
	white-space: nowrap;
	height: 78rpx;
	.item {
		text-align: center;
		display: inline-block;
		color: $font-color-base;
		margin: 26rpx 34rpx 15rpx 29rpx;
		background-color: #fff;
		line-height: 1;
		.time {
			font-family: PingFang SC;
			font-weight: bold;
			font-size: 30rpx;
			padding-bottom: 19rpx;
			&.action {
				color: #FF0000;
				border-bottom: 4rpx solid #ff0000;
			}
		}
	}
}
</style>
